'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = containerFactory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _forIn = require('lodash/forIn');

var _forIn2 = _interopRequireDefault(_forIn);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _containerHelpers = require('./containerHelpers');

var _dict = require('./dict');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function containerFactory(ComponentToWrap, _ref) {
  var fetch = _ref.fetch;
  var methods = _ref.methods;
  var done = _ref.done;
  var pending = _ref.pending;
  var failed = _ref.failed;

  (0, _invariant2.default)(ComponentToWrap, (0, _dict.badComponent)(fetch));

  var name = ComponentToWrap.displayName;
  var WrappedComponent = (0, _containerHelpers.connectComponent)(ComponentToWrap, fetch, methods, name);

  var Gambit = function (_React$Component) {
    (0, _inherits3.default)(Gambit, _React$Component);

    function Gambit(props, context) {
      (0, _classCallCheck3.default)(this, Gambit);

      var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Gambit).call(this, props, context));

      _this.state = {
        loadingFetches: 0,
        errored: false
      };
      return _this;
    }

    (0, _createClass3.default)(Gambit, [{
      key: 'runFetches',
      value: function runFetches(props) {
        var _this2 = this;

        var promiseObj = {};
        var store = this.context.store.getState();

        (0, _forIn2.default)(fetch, function (value, key) {
          if (value.grab) {
            var grab = value.grab(props.dispatch, props);
            var as = value.as(store, props);
            (0, _invariant2.default)(typeof grab === 'function', (0, _dict.badGrab)(name, key, grab));
            promiseObj[key] = grab(as);
          }
        });

        var allCallsBlocked = (0, _keys2.default)(promiseObj).every(function (x) {
          return !promiseObj[x];
        });
        if (allCallsBlocked) {
          return false;
        }

        this.setState({
          loadingFetches: this.state.loadingFetches + 1
        });

        return _bluebird2.default.props(promiseObj).then(function (object) {
          (0, _keys2.default)(object).forEach(function (key) {
            (0, _invariant2.default)(object[key], (0, _dict.badGrabReturn)(name, key, object[key]));
          });
          _this2.setState({
            loadingFetches: _this2.state.loadingFetches - 1,
            errored: false
          });
          // Workaround for https://github.com/petkaantonov/bluebird/issues/846
          return null;
        }, function (err) {
          _this2.setState({
            loadingFetches: _this2.state.loadingFetches - 1,
            errored: err
          });
        });
      }
    }, {
      key: 'componentWillMount',
      value: function componentWillMount() {
        this.runFetches(this.props);
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        this.runFetches(nextProps);
      }
    }, {
      key: 'render',
      value: function render() {
        var _state = this.state;
        var loadingFetches = _state.loadingFetches;
        var errored = _state.errored;

        if (loadingFetches !== 0 && pending) {
          return pending.call(this, WrappedComponent);
        } else if (loadingFetches === 0 && !errored) {
          if (done) {
            return done.call(this, WrappedComponent);
          }
          return _react2.default.createElement(WrappedComponent, this.props);
        } else if (loadingFetches === 0 && errored) {
          if (failed) {
            console.warn('Failed in ' + name + ': ' + errored);
            return failed.call(this, WrappedComponent);
          }
          throw new Error(errored);
        }
        return _react2.default.createElement('div', null);
      }
    }]);
    return Gambit;
  }(_react2.default.Component);

  Gambit.contextTypes = {
    store: _react2.default.PropTypes.object
  };


  Gambit.displayName = 'Container(' + name + ')';
  return Gambit;
}