'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

exports.default = manufactureReducer;

var _immutable = require('immutable');

var _immutableReducers = require('./immutableReducers');

var _immutableReducers2 = _interopRequireDefault(_immutableReducers);

var _redux = require('redux');

var _forIn = require('lodash/forIn');

var _forIn2 = _interopRequireDefault(_forIn);

var _GeneralConstants = require('./GeneralConstants');

var _GeneralConstants2 = _interopRequireDefault(_GeneralConstants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function manufactureReducer(tree) {
  var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var _ref$hearGeneral = _ref.hearGeneral;
  var hearGeneral = _ref$hearGeneral === undefined ? false : _ref$hearGeneral;
  var _ref$asImmutable = _ref.asImmutable;
  var asImmutable = _ref$asImmutable === undefined ? true : _ref$asImmutable;

  var reducers = asImmutable ? new _immutable.Map({}) : {};

  (0, _forIn2.default)(tree, function (value, key) {
    var _value = (0, _slicedToArray3.default)(value, 2);

    var defaultState = _value[0];
    var innerMethods = _value[1];

    var method = function method() {
      var prevState = arguments.length <= 0 || arguments[0] === undefined ? defaultState : arguments[0];
      var _ref2 = arguments[1];
      var type = _ref2.type;
      var rest = (0, _objectWithoutProperties3.default)(_ref2, ['type']);

      if (type === _GeneralConstants2.default.ACTION_CALLED && !hearGeneral) return prevState;

      // NB: The way we do constant matching could be done better
      return (0, _keys2.default)(innerMethods).reduce(function (prev, matchingConstants) {
        var response = innerMethods[matchingConstants];
        var doesMatch = matchingConstants.trim().split(' ').some(function (x) {
          return x === type.trim();
        });

        if (!doesMatch) return prev;
        return typeof response === 'function' ? response(rest, prevState) : response;
      }, prevState);
    };

    reducers = asImmutable ? reducers.set(key, method) : (0, _extends4.default)({}, reducers, (0, _defineProperty3.default)({}, key, method));
  });

  return asImmutable ? (0, _immutableReducers2.default)(reducers) : (0, _redux.combineReducers)(reducers);
}