'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _immutable = require('immutable');

exports.default = function (reducers) {
  return function () {
    var prevState = arguments.length <= 0 || arguments[0] === undefined ? new _immutable.Map({}) : arguments[0];
    var action = arguments[1];

    return reducers.reduce(function (prev, value, key) {
      return prev.set(key, value.call(undefined, prevState.get(key), action));
    }, new _immutable.Map({}));
  };
};